diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteMotionEvent.java AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteMotionEvent.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteMotionEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteMotionEvent.java	2016-02-16 20:32:58.000000000 +0900
@@ -0,0 +1,60 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteMotionEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private final long downTime;
+	private final long eventTime;
+	private final float x;
+	private final float y;
+	private final int action;
+	private final int source;
+	
+	public RemoteMotionEvent(long downTime, long eventTime, float x, float y, int action, int source)
+	{
+		this.downTime = downTime;
+		this.eventTime = eventTime;
+		this.x = x;
+		this.y = y;
+		this.action = action;
+		this.source = source;
+	}
+	
+	public long getDownTime()
+	{
+		return downTime;
+	}
+	
+	public long getEventTime()
+	{
+		return eventTime;
+	}
+	
+	public float getX()
+	{
+		return x;
+	}
+	
+	public float getY()
+	{
+		return y;
+	}
+	
+	public int getAction()
+	{
+		return action;
+	}
+	
+	public int getSource()
+	{
+		return source;
+	}
+	
+	public String toString()
+	{
+		return "(" + x + ", " + y + ")";
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteSensorEvent.java AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteSensorEvent.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteSensorEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteSensorEvent.java	2016-02-16 20:29:49.000000000 +0900
@@ -0,0 +1,53 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteSensorEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private int type;
+	private int sensor;
+	private float values[];
+	private int accuracy;
+	private long timestamp;
+	
+	public RemoteSensorEvent(int type, int sensor, float[] values, int accuracy, long timestamp)
+	{
+		this.type = type;
+		this.sensor = sensor;
+		this.values = values;
+		this.accuracy = accuracy;
+		this.timestamp = timestamp;
+	}
+	
+	public int getType()
+	{
+		return type;
+	}
+	
+	public int getSensor()
+	{
+		return sensor;
+	}
+	
+	public float[] getValues()
+	{
+		return values;
+	}
+	
+	public int getAccuracy()
+	{
+		return accuracy;
+	}
+	
+	public long getTimestamp()
+	{
+		return timestamp;
+	}
+	
+	public String toString()
+	{
+		return "(" + type + ": " + values[0] + ", " + values[1] + ")";
+	}
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteService.java AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteService.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteService.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteService.java	2016-09-26 17:23:55.907807739 +0900
@@ -0,0 +1,803 @@
+package com.android.server.remote;
+
+import java.io.IOException;
+import java.io.ObjectOutputStream;
+import java.net.Socket;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.List;
+
+import com.android.server.devicemanager.DeviceManagementService;
+//import android.hardware.SensorEventQueue2;
+
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.hardware.Sensor;
+import android.hardware.SensorEventListener;
+import android.hardware.input.IInputManager;
+import android.hardware.input.InputManager;
+import android.location.ILocationManager;
+import android.location.Location;
+import android.location.LocationManager;
+import android.media.MediaPlayer;
+import android.os.RemoteCallbackList;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.os.SystemClock;
+import android.os.Vibrator;
+import android.service.collaboroid.IGeneralMessageListener;
+import android.service.devicemanager.Device;
+import android.service.devicemanager.IDeviceManager;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.util.SparseIntArray;
+import android.view.KeyEvent;
+import android.view.MotionEvent;
+
+public class RemoteService extends IRemoteService.Stub
+{
+	private static final String TAG = "RemoteService";
+	// private static final int SERVERPORT = 55555;
+
+	// For Settings
+	// private static boolean isEnabled = false;
+	public static boolean ServerOn = false;
+	public static boolean isConnectedToServer = false;
+	
+	private static String serverIP;
+
+	// For Server
+	private Listener server = null;
+	private Thread serverThread = null;
+	private List<String> clientIPs = new ArrayList<String>();
+	/*
+	 * private Socket clientSocket; private ObjectInputStream inFromClient;
+	 */
+
+	// For Client
+	private Thread clientThread = null;
+	private List<String> serverIPs = new ArrayList<String>();
+	
+	// For handling connected devices
+	public static ArrayList<String> connectedDevices;
+	public static HashMap<String, Socket> deviceToSocket;
+	public static HashMap<String, AppendingObjectOutputStream> deviceToOutput;
+    public static SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput;
+    public static HashMap<String, Integer> deviceToSN; // device ip to source device number 
+    
+    /*
+     * devices which wait for response of resource request
+     * device ip to output stream
+     */
+    public static HashMap<String, ObjectOutputStream> waitForResponse;	
+	
+	/*
+	 * private static Socket socketToServer; private static ObjectOutputStream
+	 * out; private static AppendingObjectOutputStream outToServer;
+	 */
+	private Sender mSender;
+	
+	private DeviceManagementService mDeviceService;
+	//private IInputManager im;
+	
+	// for SensorEvent
+	public static SparseIntArray mSensorHandles = new SparseIntArray();
+	public static SparseIntArray mTypeToNumber = new SparseIntArray();
+	public static SparseIntArray mNumberToType = new SparseIntArray();
+	private boolean remoteSensorOn = false;
+	public static SensorEventListener mRemoteListener = null;
+	
+	Context mContext;
+	
+	public static int testValue = 0;
+	
+	// for general message
+	private final RemoteCallbackList<IGeneralMessageListener> mListeners = new RemoteCallbackList<IGeneralMessageListener>();
+	
+	// native functions
+	native void setServerOn(boolean flag);
+	native void sendRemoteEvent(int type, int sensor, float[] values, int accuracy, long timestamp, int sourceDevice);
+
+	public RemoteService(Context context)
+	{
+		mContext = context;
+		mSender = new Sender(context);
+		
+		initRemoteService();
+	}
+	
+	public boolean isServerOn()
+	{
+		return ServerOn;
+	}
+	
+	public void initRemoteService()
+	{
+		connectedDevices = new ArrayList<String>();
+		deviceToOutput = new HashMap<String, AppendingObjectOutputStream>();
+		deviceToSocket = new HashMap<String, Socket>();
+		resourceToOutput = new SparseArray<ArrayList<AppendingObjectOutputStream>>();
+		waitForResponse = new HashMap<String, ObjectOutputStream>();
+		deviceToSN = new HashMap<String, Integer>();
+		
+		for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+			resourceToOutput.append(i, new ArrayList<AppendingObjectOutputStream>());  
+		
+		mTypeToNumber.put(Sensor.TYPE_ORIENTATION, 0);
+		mTypeToNumber.put(Sensor.TYPE_PROXIMITY, 1);
+		
+		mNumberToType.put(0, Sensor.TYPE_ORIENTATION);
+		mNumberToType.put(1, Sensor.TYPE_PROXIMITY);
+	}
+	
+	public void initConnections()
+	{
+		try 
+		{
+			if(connectedDevices.size() > 0)
+				for(String deviceIP : connectedDevices)
+				{
+					deviceToSocket.get(deviceIP).close();
+					deviceToOutput.get(deviceIP).close();
+		        }
+		}
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		
+		connectedDevices.clear();
+		deviceToOutput.clear();
+		deviceToSocket.clear();
+		//resourceToOutput.clear();
+		waitForResponse.clear();
+		deviceToSN.clear();
+		
+		/////hc
+		clientIPs.clear();
+		
+		for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+			resourceToOutput.get(i).clear();  
+		
+		mTypeToNumber.clear();
+		mTypeToNumber.put(Sensor.TYPE_ORIENTATION, 0);
+		mTypeToNumber.put(Sensor.TYPE_PROXIMITY, 1);
+		
+		mNumberToType.clear();
+		mNumberToType.put(0, Sensor.TYPE_ORIENTATION);
+		mNumberToType.put(1, Sensor.TYPE_PROXIMITY);
+	}
+	
+	@Override
+	public boolean startServer()
+	{
+		// TODO Auto-generated method stub
+
+		if (!ServerOn)
+		{
+			server = new Listener(mContext);
+			serverThread = new Thread(server);
+			Log.d(TAG, "Starting Listener!");
+			serverThread.start();
+
+			ServerOn = true;
+			//setServerOn(true);
+
+			ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+			try
+			{
+				mLocationManager.setRemoteProviderEnabled(true);
+			} catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+		Log.d(TAG, "startServer - onServer: " + ServerOn);
+
+		return ServerOn;
+	}
+
+	@Override
+	public boolean stopServer()
+	{
+		Log.d(TAG, "HELLO - 0");
+		
+		// TODO Auto-generated method stub
+		if (ServerOn)
+		{
+		    Log.d(TAG, "Stopping Listener: " + serverThread);
+			if (serverThread != null)
+			{
+				server.terminate();
+				serverThread.interrupt();
+
+				ServerOn = false;
+				setServerOn(false);
+				// Settings.System.putString(mContext.getContentResolver(),
+				// "enableRemoteRequest", "false");
+				/*
+				 * } catch (InterruptedException e) { // TODO Auto-generated
+				 * catch block e.printStackTrace(); }
+				 */
+				
+				ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+				try
+				{
+					mLocationManager.setRemoteProviderEnabled(false);
+				} catch (RemoteException e)
+				{
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		}
+
+		Log.d(TAG, "End stopServer - onServer: " + ServerOn);
+
+		return !ServerOn;
+	}
+
+	@Override
+	public List<String> getClientIPs(){
+	    return clientIPs = Listener.getClientIPs();
+	}
+
+	@Override
+	public List<String> getServerIPs(){
+	    return serverIPs;
+	}
+	
+	@Override
+	public void printServerIPs(){
+	    
+	}
+	
+	@Override
+	public void sendAllrequestVib(RemoteRequest request){
+	    
+	    try{
+	        mSender.sendVib(request);
+	    } catch(IOException e){
+	        e.printStackTrace();
+	    }
+	    
+	}
+	
+	@Override
+	public void sendAllrequest(RemoteRequest request)
+	{
+	    mSender.sendRequestToEveryDevices(request);
+	}
+
+	@Override
+    public void sendAllMusic(int sampleSize, byte[] sampleData, long presentationTime){
+//        Log.d(TAG, "Music testing");
+        
+        SdPackage MDtoSend = new SdPackage(sampleSize, sampleData, presentationTime);
+        
+        mSender.sendMusicData(MDtoSend);
+        
+        /*Collection<AppendingObjectOutputStream> temp = connectedDevices.values();
+        for (AppendingObjectOutputStream outToServer : temp){
+            try {
+                outToServer.writeObject(MDtoSend);
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+        }*/
+    }
+	
+	@Override
+	public void setConfiguration()
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, "RemoteRequesT!!!!");
+	}
+
+	@Override
+	public void setEnabled(boolean isEnabled) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		// RemoteRequestHandler.isEnabled = isEnabled;
+	}
+
+	@Override
+	public boolean connectToServer(String ip)
+	{
+		
+		
+		return isConnectedToServer;
+	}
+
+	@Override
+	public void disconnectToServer()
+	{
+	    serverIPs.clear();
+        clientIPs.clear();
+        connectedDevices.clear();
+		if (isConnectedToServer)
+		{
+			clientThread.interrupt();
+			
+			// client.terminate();
+			isConnectedToServer = false;
+			// Settings.System.putString(mContext.getContentResolver(),
+			// "enableRemoteRequest", "false");
+			ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+			try
+			{
+				mLocationManager.setRemoteProviderEnabled(false);
+			} catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		// }
+		/*
+		 * catch (InterruptedException e) { // TODO Auto-generated catch block
+		 * e.printStackTrace(); }
+		 */
+	}
+	
+	public boolean setRemoteSensorOn(boolean flag, SensorEventListener listener)
+	{
+		remoteSensorOn = flag;
+		mRemoteListener = listener;
+		
+		return remoteSensorOn;
+	}
+	
+	@Override
+	public boolean sendResourceRequests(List<Device> requestDeviceList) throws RemoteException {
+		// TODO Auto-generated method stub
+		mSender.connectToRemoteDevices(requestDeviceList);
+		
+		return true;
+	}
+	
+	@Override
+	/*public int[] isAllowedForResource(String device, int[] resources) throws RemoteException 
+	{
+		// TODO Auto-generated method stub
+		IDeviceManager deviceManager = IDeviceManager.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+		ArrayList<Integer> allowed = new ArrayList<Integer>();
+		
+		for(int resource : resources)
+			if(deviceManager.isAllowedForResource(device, resource))
+				allowed.add(resource);
+				
+		mSender.addRemoteDevice(allowed, device);
+		int[] ret = new int[allowed.size()];
+		
+		for(int i=0; i<allowed.size(); i++)
+			ret[i] = allowed.get(i);
+		
+		return ret;
+	}*/
+	
+	public boolean isAllowedForResource(String deviceName, String deviceIP, int[] resources) throws RemoteException 
+	{
+		// TODO Auto-generated method stub
+		IDeviceManager deviceManager = IDeviceManager.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+		
+		deviceManager.showRequestDialog(deviceName, deviceIP, resources);
+		
+		return true;
+	}
+	
+	public boolean respondAllowedResources(String deviceIP, int[] resources)
+	{
+		try {
+			// add remote device
+			mSender.addRemoteDevice(resources, deviceIP);
+			
+			waitForResponse.get(deviceIP).writeObject(resources);
+			waitForResponse.remove(deviceIP);
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		return true;
+	}
+	
+	
+	
+	
+	@Override
+	public boolean sendRequest(RemoteRequest request)
+	{
+		if(isConnectedToServer)
+		{
+		}
+		return false;
+	}
+	
+	//for MotionEvent
+	@Override
+	public void sendMotionEvent(MotionEvent event)
+	{
+//		Log.d(TAG, event.toString());
+		if(isConnectedToServer)
+			mSender.sendMotionEvent(event);
+	}
+	
+	// for KeyEvent
+	@Override
+	public void sendKeyEvent(KeyEvent event) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+//		RemoteKeyEvent rke = new RemoteKeyEvent(event.getAction(),
+//				event.getKeyCode(), event.getSource());
+//
+//		if (isConnectedToServer)
+//			client.sendKeyEvent(rke);
+	}
+
+	@Override
+	public void addSensorHandle(int type, int handle)
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, mSensorHandles.toString());
+
+		mSensorHandles.put(type, handle);
+	}
+	
+	@Override
+	public void removeSensorHandle(int type)
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, "type: " + type);
+		mSensorHandles.delete(type);
+	}
+	
+	@Override
+	public void sendSensorEvent(int type, int sensor, float[] values,
+			int accuracy, long timestamp)
+	{
+		RemoteSensorEvent rse = new RemoteSensorEvent(type, sensor, values,
+				accuracy, timestamp);
+
+		if (isConnectedToServer)
+		    mSender.sendSensorEvent(rse);
+	}
+	
+	@Override
+	public int getVideoPlayers(){
+	    int numberOfPlayers = 0;
+	    if(isConnectedToServer){
+	        numberOfPlayers = resourceToOutput.get(Device.RESOURCE_TYPE_VIDEO).size();
+	    }
+	    return numberOfPlayers;
+	}
+	
+	@Override
+	public void sendVideoSignal(int vport){
+	    if(isConnectedToServer){
+	        mSender.sendVideoSignal(vport);
+	    }
+	}
+	
+	
+	public void sendMusicData(int sampleSize, byte[] sampleData, long presentationTime){
+
+		
+		SdPackage MDtoSend = new SdPackage(sampleSize, sampleData, presentationTime);
+		
+		if(isConnectedToServer){
+		    mSender.sendMusicData(MDtoSend);
+		}
+	}
+	
+	@Override
+	public void sendLocation(Location location)
+	{
+		if(isConnectedToServer)
+			mSender.sendLocation(location);
+	}
+	
+	Object sendRountTripRequest(RemoteRequest request)
+	{
+		return null;
+	}
+
+	@Override
+	public void testOperation() throws RemoteException
+	{
+		Log.d(TAG, "testOperation - START!");
+
+		for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+			Log.d(TAG, i + " - " + resourceToOutput.get(i).size());
+				
+	}
+	
+	public void playMusic()
+	{
+		Log.d(TAG, "playMusic - START!");
+		MediaPlayer mp = new MediaPlayer();
+		try
+		{
+			mp.setDataSource("/storage/emulated/legacy/Music/sabbun.mp3");
+			mp.prepare();
+		} catch (IllegalArgumentException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (SecurityException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IllegalStateException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IOException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		// mp.start();
+	}
+	
+	public void testMethod(int value)
+	{
+		testValue = value;
+	}
+	
+	@Override  
+	public void testVibrate() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+//	    ArrayList<Object> para = new ArrayList<Object>();
+//	    para.add("100");
+//	    RemoteRequest request = new RemoteRequest("systemCall", "vibrate", para);
+//	    
+//        client.send(request);
+        Vibrator v = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+        
+        v.vibrate(200);
+		
+	}
+	@Override
+	public void testMusic() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		
+	}
+	
+	@Override
+	public void testVideo() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		
+	}
+	
+	@Override
+	public void testTouch() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		IInputManager mInputService = IInputManager.Stub.asInterface(ServiceManager.getService("input"));
+		
+		MotionEvent event = MotionEvent.obtain(
+				SystemClock.uptimeMillis(),
+				SystemClock.uptimeMillis(), 
+				(MotionEvent.ACTION_DOWN + (1 << 24)),
+				100,
+				100, 0);
+		
+				event.setSource(MotionEvent.TOOL_TYPE_FINGER);
+
+		try
+		{
+			if (!mInputService.injectInputEvent(event, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+			{
+				Log.d(TAG, "FAIL!!!!!");
+			}
+		}
+		finally
+		{
+			event.recycle();
+		}
+		
+		for(int i=1; i<10; i++)
+		{
+			MotionEvent event1 = MotionEvent.obtain(
+					SystemClock.uptimeMillis(),
+					SystemClock.uptimeMillis(), 
+					(MotionEvent.ACTION_MOVE + (1 << 24)),
+					100 * i,
+					100 * i, 0);
+			
+					event1.setSource(MotionEvent.TOOL_TYPE_FINGER);
+	
+			try
+			{
+				if (!mInputService.injectInputEvent(event1, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+				{
+					Log.d(TAG, "FAIL!!!!!");
+				}
+			}
+			finally
+			{
+				event.recycle();
+			}
+		}
+		
+		MotionEvent event2 = MotionEvent.obtain(
+				SystemClock.uptimeMillis(),
+				SystemClock.uptimeMillis(), 
+				(MotionEvent.ACTION_UP + (1 << 24)),
+				900,
+				900, 0);
+		
+				event2.setSource(MotionEvent.TOOL_TYPE_FINGER);
+
+		try
+		{
+			if (!mInputService.injectInputEvent(event2, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+			{
+				Log.d(TAG, "FAIL!!!!!");
+			}
+		}
+		finally
+		{
+			event.recycle();
+		}
+	}
+	
+	@Override
+	public void testKey() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		
+	}
+	
+	@Override
+	public void testSensor() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		new Thread(new Runnable()
+		{
+			@Override
+			public void run()
+			{
+				float[] temp;
+				
+				for(int i=0; i<10; i++)
+				{
+					temp = new float[3];
+					temp[0] = 10;
+					temp[1] = 20;
+					temp[2] = 30;
+				
+				
+				//SensorEvent se = new SensorEvent(temp, 0, 0, 0);
+				
+				//Log.d(TAG, remoteSensorOn + " - " + se.toString());
+				
+				//sendRemoteEvent(Sensor.TYPE_REMOTE_SENSOR, Sensor.TYPE_REMOTE_SENSOR, temp, 0, 1000, 1);
+				
+				sendRemoteEvent(3,
+						32, 
+						temp,
+						0, 
+						System.currentTimeMillis(),
+						1);
+				
+				}
+			}
+		}).start();
+	}
+	
+	@Override
+	public void testLocation() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		new Thread(new Runnable()
+		{
+			@Override
+			public void run()
+			{
+				ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+				
+				for(int i=0; i<10; i++)
+				{
+					Location location = new Location(LocationManager.GPS_PROVIDER);
+					//location.setProvider(LocationManager.GPS_PROVIDER);
+					location.setAccuracy(34);
+					location.setTime(System.currentTimeMillis());
+					location.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+					location.setLatitude((Math.random()*10));
+					location.setLongitude((Math.random()*10));
+					
+					try
+					{
+						mLocationManager.reportLocation(location, false);
+					} 
+					catch (RemoteException e)
+					{
+						// TODO Auto-generated catch block
+						e.printStackTrace();
+					}
+					
+					try {
+                        Thread.sleep(1000);
+                    } catch (InterruptedException e) {
+                        // TODO Auto-generated catch block
+                        e.printStackTrace();
+                    }
+					
+//					Location location2 = new Location(LocationManager.REMOTE_PROVIDER);
+					//location.setProvider(LocationManager.GPS_PROVIDER);
+//					location2.setAccuracy(34);
+//					location2.setTime(System.currentTimeMillis());
+//					location2.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+//					location2.setLatitude((10-i)*123.456);
+//					location2.setLongitude((10-i)*123.456);
+//					
+//					try
+//					{
+//						mLocationManager.reportLocation(location2, false);
+//					} 
+//					catch (RemoteException e)
+//					{
+//						// TODO Auto-generated catch block
+//						e.printStackTrace();
+//					}
+					//location.reset();
+				}
+			}
+		}).start();
+	}
+	
+	public void requestMotionEvents() throws RemoteException{
+	    ArrayList<Object> para = new ArrayList<Object>();
+	    RemoteRequest request = new RemoteRequest("request", "motion", para);
+	    sendAllrequest(request);
+	}
+	
+	public void launchDummyApp(){
+	    ArrayList<Object> para = new ArrayList<Object>();
+        RemoteRequest request = new RemoteRequest("request", "dummyApp", para);
+        sendAllrequest(request);
+	}
+	@Override
+	public void registerListener(IGeneralMessageListener listener) throws RemoteException {
+		// TODO Auto-generated method stub
+		mListeners.register(listener);
+	}
+	@Override
+	public void unregisterListener(IGeneralMessageListener listener) throws RemoteException {
+		// TODO Auto-generated method stub
+		mListeners.unregister(listener);
+	}
+	
+	public void sendMessageToListener(String msg)
+	{
+		final int length = mListeners.beginBroadcast();
+		for(int i=0; i<length; i++)
+		{
+			final IGeneralMessageListener listener = mListeners.getBroadcastItem(i);
+			if(listener != null)
+			{
+				try {
+					listener.onMessageReceived(msg);
+				} catch (RemoteException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		}
+		mListeners.finishBroadcast();
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/ResourceRequest.java AndroidSource/frameworks/base/services/java/com/android/server/remote/ResourceRequest.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/ResourceRequest.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/ResourceRequest.java	2016-06-22 20:40:33.000000000 +0900
@@ -0,0 +1,27 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class ResourceRequest implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private String deviceName;
+	private int[] resources;
+	
+	public ResourceRequest(String dn, int[] rs)
+	{
+		deviceName = dn;
+		resources = rs;
+	}
+	
+	public String getDeviceName()
+	{
+		return deviceName;
+	}
+
+	public int[] getRequestedResources()
+	{
+		return resources;
+	}
+}
